FelwoodFarmer = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0","AceDB-2.0", "CandyBar-2.0")
local L = AceLibrary("AceLocale-2.2"):new("FelwoodFarmer")
FelwoodFarmer:RegisterDB("FelwoodFarmerDB", "FelwoodFarmerDBPC")
FelwoodFarmer:RegisterDefaults("profile", {
	scale = 0.8,
})

function FelwoodFarmer:OnInitialize()
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	if (not Cartographer_Notes) then
		self:RegisterEvent("WORLD_MAP_UPDATE")
	end
	self.TIMER_FULL		= 1505
	self.WRT_TEXTURE	= "Interface\\Icons\\INV_Misc_Food_55"
	self.NDB_TEXTURE	= "Interface\\Icons\\INV_Misc_Food_45"
	self.WBB_TEXTURE	= "Interface\\Icons\\INV_Misc_Food_58"
	self.SF_TEXTURE		= "Interface\\Icons\\Spell_Holy_MindVision"
	self.WRT_MAPTEXTURE	= "Interface\\Addons\\FelwoodFarmer\\icons\\Tuber.tga"
	self.NDB_MAPTEXTURE	= "Interface\\Addons\\FelwoodFarmer\\icons\\Sprout.tga"
	self.WBB_MAPTEXTURE	= "Interface\\Addons\\FelwoodFarmer\\icons\\Berries.tga"
	self.SF_MAPTEXTURE	= "Interface\\Addons\\FelwoodFarmer\\icons\\Songflower.tga"
	self.COL_WRT		= "yellow"
	self.COL_NDB		= "green"
	self.COL_WBB		= "purple"
	self.COL_SF		= "orange"
	self.db.profile.scale	= 0.8
	self.PLANTDB = {
		[1] = {x=0.49422,y=0.12180,item = L["Whipper Root Tuber"],location = L["North Felwood"]}, 
		[2] = {x=0.42464,y=0.13907,item = L["Night Dragon's Breath"],location = L["Jadefire Run"]},
		[3] = {x=0.40734,y=0.19131,item = L["Whipper Root Tuber"],location = L["Jadefire Run"]},
		[4] = {x=0.50582,y=0.18256,item = L["Whipper Root Tuber"],location = L["Irontree Woods"]},
		[5] = {x=0.50579,y=0.30435,item = L["Night Dragon's Breath"],location = L["Graveyard"]},
		[6] = {x=0.43041,y=0.46959,item = L["Whipper Root Tuber"],location = L["Bloodvenom Falls"]},
		[7] = {x=0.34061,y=0.60232,item = L["Whipper Root Tuber"],location = L["Jaedenar"]}, 
		[8] = {x=0.35109,y=0.58927,item = L["Night Dragon's Breath"],location = L["Jaedenar"]}, 
		[9] = {x=0.40725,y=0.78261,item = L["Night Dragon's Breath"],location = L["Jadefire Glen"]}, 
		[10] = {x=0.40145,y=0.85222,item = L["Whipper Root Tuber"],location = L["Jadefire Glen"]},
		[11] = {x=0.55798,y=0.06958,item = L["Windblossom Berries"],location = L["North Felwood"]},
		[12] = {x=0.45367,y=0.18258,item = L["Windblossom Berries"],location = L["Jadefire Run"]},
		[13] = {x=0.38790,y=0.21944,item = L["Windblossom Berries"],location = L["Jadefire Run"]},
		[14] = {x=0.44783,y=0.41744,item = L["Windblossom Berries"],location = L["Shatter Scar Vale"]},
		[15] = {x=0.34343,y=0.48698,item = L["Windblossom Berries"],location = L["Bloodvenom River"]},
		[16] = {x=0.38985,y=0.59123,item = L["Windblossom Berries"],location = L["Jaedenar"]},
		[17] = {x=0.36554,y=0.61964,item = L["Windblossom Berries"],location = L["Jaedenar"]},
		[18] = {x=0.50005,y=0.80001,item = L["Windblossom Berries"],location = L["Emerald Sanctuary"]},
		[19] = {x=0.55217,y=0.23478,item = L["Windblossom Berries"],location = L["Irontree Woods"]},
		[20] = {x=0.57535,y=0.20001,item = L["Windblossom Berries"],location = L["Irontree Woods"]},
		[21] = {x=0.48260,y=0.75654,item = L["SongFlower"],location = L["Emerald Sanctuary"]},
		[22] = {x=0.63910,y=0.06087,item = L["SongFlower"],location = L["Felpaw Village"]},
		[23] = {x=0.45944,y=0.85223,item = L["SongFlower"],location = L["Jadefire Glen"]},
		[24] = {x=0.40145,y=0.44355,item = L["SongFlower"],location = L["Shatter Scar Vale"]},
		[25] = {x=0.40141,y=0.56524,item = L["SongFlower"],location = L["Jaedenar"]},
		[26] = {x=0.34348,y=0.52178,item = L["SongFlower"],location = L["Bloodvenom Post"]}
	}
	if (Cartographer_Notes) then
		Cartographer_Notes:RegisterIcon(L["Whipper Root Tuber"],{path=self.WRT_MAPTEXTURE,text=L["Whipper Root Tuber"]})
		Cartographer_Notes:RegisterIcon(L["Night Dragon's Breath"],{path=self.NDB_MAPTEXTURE,text=L["Night Dragon's Breath"]})
		Cartographer_Notes:RegisterIcon(L["Windblossom Berries"],{path=self.WBB_MAPTEXTURE,text=L["Windblossom Berries"]})
		Cartographer_Notes:RegisterIcon(L["SongFlower"],{path=self.SF_MAPTEXTURE,text=L["SongFlower"]})
		for k,v in ipairs(FelwoodFarmer.PLANTDB) do 
			if (not Cartographer_Notes:GetNote(L["Felwood"],v.x,v.y)) then
				Cartographer_Notes:SetNote(L["Felwood"],v.x,v.y,v.item,"Treasure")
			end
		end
	end

end
function FelwoodFarmer:OnEnable()
	self:RegisterEvent("CHAT_MSG_LOOT")
	self:RegisterEvent("PLAYER_AURAS_CHANGED")
end

function FelwoodFarmer:OnDisable()
	if (self:IsEventRegistered("CHAT_MSG_LOOT")) then
		self:UnregisterEvent("CHAT_MSG_LOOT")
	end
	if (self:IsEventRegistered("PLAYER_AURAS_CHANGED")) then
		self:UnregisterEvent("PLAYER_AURAS_CHANGED")
	end
end
FelwoodFarmer:RegisterChatCommand({ "/qfwg" }, {
    type = 'group',
    args = {
        anchor = {
            type = "toggle",
            name = "Anchor",
            desc = "Toggle the Anchor",
            set = function()
                FelwoodFarmer:TogAnchor()
            end,
            get = function()
		    if (FelwoodFarmerAnchor:IsVisible()) then
			return true
		    end
            end
        },
	--scale = {
	--	type = "range",
	--	name = "Scale",
	--	desc = "Set the size of the timer bars.",
	--	set = function()
	--		FelwoodFarmer.db.profile.scale = tonumber(value)
	--	end,
	--	get = function()
	--		return FelwoodFarmer.db.profile.scale
	--	end,
	--	min = 0.4,
	--	max = 5.0,
	--	error = "Scale must be between 0.4 and 5.0",
	--}
    }
})

--<<---------------------------------->>--
--		Event Handlers		--
--<<---------------------------------->>--

function FelwoodFarmer:CHAT_MSG_LOOT()
	local str = arg1
	local x,y
	if string.find(str, L["Night Dragon's Breath"])	
		or string.find(str, L["Windblossom Berries"])	
		or string.find(str, L["Whipper Root Tuber"]) then
		self:StartTimer()
	end
end
function FelwoodFarmer:PLAYER_AURAS_CHANGED()
	self:CheckSFBuff()
end
function FelwoodFarmer:WORLD_MAP_UPDATE()
	if (GetCurrentMapContinent() == 1 and GetCurrentMapZone() == 10) then
		if (not Cartographer_Notes) then
			self.FrameWidth = WorldMapDetailFrame:GetWidth()
			self.FrameHeight = WorldMapDetailFrame:GetHeight()
			FelwoodMapOverlayFrame:Show()
			self:MainDraw()		
		end
	elseif (FelwoodMapOverlayFrame:IsVisible()) then
		FelwoodMapOverlayFrame:Hide()
	end
end
function FelwoodFarmer:ZONE_CHANGED_NEW_AREA()
	local curZone = GetZoneText()
	if( (curZone ~= nil) and curZone == L["Felwood"]) then
		self:OnEnable()
	else
		self:OnDisable()
	end
end

--<<---------------------------------->>--
--		Functions		--
--<<---------------------------------->>--
function FelwoodFarmer:BarTest()
	self:StartBar("Test 1",FelwoodFarmer.WRT_TEXTURE,10,"yellow")
	self:StartBar("Test 2",FelwoodFarmer.NDB_TEXTURE,15,"green")
	self:StartBar("Test 3",FelwoodFarmer.WBB_TEXTURE,20,"purple")
	self:StartBar("Test 4",FelwoodFarmer.SF_TEXTURE,25,"orange")
end
function FelwoodFarmer:TogAnchor()
	if (FelwoodFarmerAnchor:IsVisible()) then
		FelwoodFarmerAnchor:Hide()
	else	
		FelwoodFarmerAnchor:Show()
	end
end

function FelwoodFarmer:StartBar(title,texture, colour)
	if (not self:IsCandyBarGroupRegistered("FelwoodFarmerBars")) then
		self:RegisterCandyBarGroup("FelwoodFarmerBars")
		self:SetCandyBarGroupGrowth("FelwoodFarmerBars", false)
		self:SetCandyBarGroupPoint("FelwoodFarmerBars", "TOPLEFT", "FelwoodFarmerAnchor", "BOTTOMLEFT", 0, 0)
	end
	self:RegisterCandyBar(title, self.TIMER_FULL, title, texture, colour)
	self:RegisterCandyBarWithGroup(title, "FelwoodFarmerBars")
	function FelwoodFarmerBarDone(title)
		self:UpdateCandyBarGroup("FelwoodFarmerBars")
	end
	self:SetCandyBarScale(title,self.db.profile.scale)
	self:SetCandyBarCompletion(title, FelwoodFarmerBarDone, title)
	self:StartCandyBar(title, true)  
end
function FelwoodFarmer:StartTimer()
	local x,y = GetPlayerMapPosition("player")
	local colour,texture
	x = x
	y = y
	for k,v in ipairs(FelwoodFarmer.PLANTDB) do 
		if (v.item == L["Windblossom Berries"]) then
			colour = FelwoodFarmer.COL_WBB
			texture = FelwoodFarmer.WBB_TEXTURE
		elseif (v.item == L["SongFlower"]) then
			colour = FelwoodFarmer.COL_SF
			texture = FelwoodFarmer.SF_TEXTURE
		elseif (v.item == L["Whipper Root Tuber"]) then
			colour = FelwoodFarmer.COL_WRT
			texture = FelwoodFarmer.WRT_TEXTURE
		elseif (v.item == L["Night Dragon's Breath"]) then
			colour = FelwoodFarmer.COL_NDB
			texture  = FelwoodFarmer.NDB_TEXTURE
		end
		if( (v.x - x)*(v.x - x)+(v.y - y)*(v.y - y) < 0.0002) then
			self:StartBar(v.location.." - "..v.item,texture,colour)
		end
	end
end

function FelwoodFarmer:CheckSFBuff()
	for i=0,23 do
		if (GetPlayerBuffTexture(i) ~= nil and GetPlayerBuffTexture(i) == FelwoodFarmer.SF_TEXTURE and 3590 < GetPlayerBuffTimeLeft(i)) then
			self:StartTimer()
		end
	end
end

function FelwoodFarmer:MainDraw()
	local texture
	for k,v in ipairs(FelwoodFarmer.PLANTDB) do 
		if (v.item == L["Windblossom Berries"]) then
			texture = FelwoodFarmer.WBB_TEXTURE
		elseif (v.item == L["SongFlower"]) then
			texture = FelwoodFarmer.SF_TEXTURE
		elseif (v.item == L["Whipper Root Tuber"]) then
			texture = FelwoodFarmer.WRT_TEXTURE
		elseif (v.item == L["Night Dragon's Breath"]) then
			texture  = FelwoodFarmer.NDB_TEXTURE
		end
		-- set texture
		local mainNoteTexture = getglobal("FelwoodMain"..k.."Texture")
		if mainNoteTexture then 
			mainNoteTexture:SetTexture(texture)
			mainNoteTexture:SetVertexColor(1,1,1,1)
		end
		-- draw icon
		local mainNote = getglobal("FelwoodMain"..k)
		mnX = v.x * self.FrameWidth
		mnY = -v.y * self.FrameHeight
		mainNote:SetPoint("CENTER", "FelwoodMapOverlayFrame", "TOPLEFT", mnX, mnY)
		mainNote:Show()
		mainNote.toolTip = format("%s - %s", v.item, v.location)
	end
end
